;*****************************************************
; Sample source program 'ARGSplit.asm'               *
; Copyright (C) 2014. COHT Inc. All Rights Reserved. *
;*****************************************************
;
; predefined handle value
;
STD_IN  equ     0        ; std_in handle
STD_OUT equ     1        ; std_out handle
STD_ERR equ     2        ; std_err handle
;
; Program Segment Prefix
;
ARG_LEN equ     80h      ; command parameter length
ARG_BUF equ     81h      ; command parameters
;
        ORG     0100H
Entry:
        xor     ax,ax
        mov     [ARGC],al; clear ARGC
        mov     bx,ARGV  ; top of ARGV array
;
        mov     cl,[ARG_LEN]; get command line string length
        xor     ch,ch    ; clear upper byte
        mov     si,ARG_BUF; get command line pointer
        cld              ; increase direction
;
ArgGet:
        jcxz    PrintOut ; jump if end of command line
        lodsb            ; get next letter
        dec     cx       ; decrement counter
        cmp     al,20h   ; printable letter?
        jle     ArgGet   ; jump if not
;
        mov     al,[ARGC]; increment ARGC
        inc     al
        mov     [ARGC],al
        mov     ax,si    ; get parameter address in AX
        dec     ax
        mov     [bx],ax  ; store to ARGV
        add     bx,2     ; ARGV++
;
ParaLoop:
        jcxz    PrintOut ; jump if end of command line
        lodsb            ; get next letter
        dec     cx       ; decrement counter
        cmp     al,20h   ; printable letter?
        jle     ArgGet   ; jump if not
        jmp     ParaLoop ; stay in parameter loop
;
PrintOut:
        mov     cl,[ARGC]; get ARGC
        jcxz    ProcEnd  ; jump if no-args
        mov     si,ARGV  ; top of ARGV array
;
PrntLoop:
        push    cx       ; save ARGC
        lodsw            ; get parameter address
        mov     dx,ax
        call    StrLen   ; get string length in CX
;
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
;
        mov     dx,CRLF  ; CR/LF
        mov     cx,2
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
        pop     cx       ; restore ARGC
        loop    PrntLoop
;
ProcEnd:
        mov     al,0     ; return code
        mov     ah,4ch   ; end program function
        int     21h
;
; subroutine StrLen
; AX = IN:String pointer
; CX = OUT:String length
;
StrLen  equ     $
        pushf            ; save regs
        push    ax
        push    si
        xor     cx,cx    ; clear counter
        mov     si,ax    ; SI is source string
        cld              ; increase direction
;
PrintChr:
        lodsb            ; get one character
        cmp     al,20h   ; comp with space code(separator)
        jle     SpaceChr ; jump if less or equal
;
        inc     cx       ; increment count
        jmp     PrintChr ; loop
;
SpaceChr:
        pop     si       ; restore regs
        pop     ax
        popf
        ret
;
ARGC:   db      0        ; argument count
ARGV:   dw      0        ; argument vector array
        ds      124      ; 2 * 62byte
CRLF:   db      13,10
        end
