;*****************************************************
; Sample source program 'Calculat.asm'               *
; Copyright (C) 2014. COHT Inc. All Rights Reserved. *
;*****************************************************
        ORG     0100H
Entry:
        mov     dx,Prompt1 ; Enter first value:
        mov     ah,09h     ; output string
        int     21h
;
        mov     bx,BUFFER1 ; Buffer address
        mov     cx,8       ; Buffer length
        call    NumInput
;
OpePrmpt:
        mov     dx,Prompt2 ; Enter operator(+-*/):
        mov     ah,09h
        int     21h
;
OpeInput:
        mov     ah,07h   ; input from stdin
        int     21h
        cmp     al,2ah   ; '*'
        jz      OpeEcho
;
        cmp     al,2bh   ; '+'
        jz      OpeEcho
;
        cmp     al,2dh   ; '-'
        jz      OpeEcho
;
        cmp     al,2fh   ; '/'
        jz      OpeEcho
;
        mov     dl,07h   ; BEL code
        mov     ah,02h   ; output to stdout
        int     21h
        jmp     OpeInput ; get next key code
;
OpeEcho:
        mov     byte ptr OPERATOR,al
        mov     dl,al    ; echo character
        mov     ah,02h   ; output to stdout
        int     21h
;
        mov     dx,CRLF  ; CR/LF
        mov     ah,09h   ; output string
        int     21h
;
ValPrmpt:
        mov     dx,Prompt3 ; Enter second value:
        mov     ah,09h     ; output string
        int     21h
;
        mov     bx,BUFFER2 ; Buffer address
        mov     cx,8       ; Buffer length
        call    NumInput
;
        mov     dx,Leader ; Calcurate result is 
        mov     ah,09h    ; output string
        int     21h
;
        mov     si,BUFFER1 ; Buffer address-1
        mov     di,BUFFER2 ; Buffer address-2
        mov     cx,8       ; Buffer length
        mov     al,[OPERATOR]; get operator
;
        cmp     al,2ah   ; '*'
        jnz     PlusOpe
        call    DwordMul ; multiply
;       call    DWMul2   ; multiply(another algorithm)
        jmp     OutReslt
;
PlusOpe:
        cmp     al,2bh   ; '+'
        jnz     MinusOpe
        call    DwordAdd ; addition
        jmp     OutReslt
;
MinusOpe:
        cmp     al,2dh   ; '-'
        jnz     DividOpe
        call    DwordSub ; subtraction
        jmp     OutReslt
;
DividOpe:
        call    DwordDiv ; divide
        call    NumOutput; result output
;
        mov     dx,Rest  ; Rest is 
        mov     ah,09h   ; output string
        int     21h
;
        mov     ax,cx    ; rest value(low)
        mov     dx,bx    ; rest value(high)
OutReslt:
        call    NumOutput; result output
;
        mov     dx,CRLF  ; CR/LF
        mov     ah,09h   ; output string
        int     21h
;
        mov     ah,4ch   ; program terminate
        mov     al,0     ; return code
        int     21h
Prompt1:db      "Enter first value: $"
Prompt2:db      "Enter operator(+-*/): $"
Prompt3:db      "Enter second value: $"
Leader: db      "Calcurated result is $"
Rest:   db      " Rest is $"
OPERATOR:db     0
BUFFER1:ds      8        ; first value string buffer
BUFFER2:ds      8        ; second value string buffer

;
; Subroutine DwordAdd/DwordSub/DwordMul/DwordDiv
; SI = IN:First value string buffer
; DI = IN:Second value string buffer
; CX = IN:Max number length
; DX:AX = OUT:Result
; BX:CX = OUT:Rest(DwordDiv)
;
DwordAdd equ    $
        push    cx       ; save regs
        push    bx
        mov     bx,di
        call    HexDecml ; convert second string buffer to hex
;
        push    ax       ; save second value
        push    dx
        mov     bx,si
        call    HexDecml ; convert first string buffer to hex
;
        pop     bx       ; restore second value
        pop     cx
        add     ax,cx    ; add as dword
        adc     dx,bx
        pop     bx       ; restore regs
        pop     cx
        ret
;
DwordSub equ    $
        push    cx       ; save regs
        push    bx
        mov     bx,di
        call    HexDecml ; convert second string buffer to hex
;
        push    ax       ; save second value
        push    dx
        mov     bx,si
        call    HexDecml ; convert first string buffer to hex
;
        pop     bx       ; restore second value
        pop     cx
        sub     ax,cx    ; subtract as dword
        sbb     dx,bx
        pop     bx       ; restore regs
        pop     cx
        ret
;
DwordMul equ    $
        push    cx       ; save regs
        push    bx
        push    si
        push    di
        xor     ax,ax
        mov     [MULWK1],ax; initialize with zero
        mov     [MULWK2],ax
        mov     [MULWK3],ax
        mov     [MULWK4],ax
;
        mov     bx,di
        call    HexDecml ; convert second string buffer to hex
        push    ax       ; save second value
        push    dx
;
        mov     bx,si
        call    HexDecml ; convert first string buffer to hex
        pop     si       ; restore second value
        pop     di
        xor     bx,bx    ; bx=b16-b48
        mov     cx,16    ; loop 16bits
;
; calculate b0-b47
;
Lo48Mul:
        or      si,si    ; calc end?
        jnz     LoMul10  ; branch if not
        or      di,di    ; calc end?
        jz      DWMulRet ; branch if so
;
LoMul10
        shr     si,1     ; get least significant bit in carry
        rcr     di,1
        jnc     LoMul50  ; skip if zero
;
        add     [MULWK1],ax; add first value to result
        adc     [MULWK2],dx
        adc     [MULWK3],bx
LoMul50:
        sal     ax,1     ; left shift first value
        rcl     dx,1
        rcl     bx,1
        loop    Lo48Mul
;
; calculate b16-b63
;
Hi48Mul:
        or      si,si    ; calc end?
        jnz     HiMul10  ; branch if not
        or      di,di    ; calc end?
        jz      DWMulRet ; branch if so
;
HiMul10
        shr     si,1     ; get least significant bit in carry
        rcr     di,1
        jnc     HiMul50  ; skip if zero
;
        add     [MULWK2],dx; add first value to result
        adc     [MULWK3],bx
        adc     [MULWK4],ax; now ax is b48-b63
HiMul50:
        sal     dx,1     ; left shift first value
        rcl     bx,1
        rcl     ax,1
        jmp     Hi48Mul  ; loop until end
;
DWMulRet:
        mov     ax,[MULWK1]; get result low 32bits
        mov     dx,[MULWK2]
        pop     di       ; restore regs
        pop     si
        pop     bx
        pop     cx
        ret
;
MULWK1: dw      0
MULWK2: dw      0
MULWK3: dw      0
MULWK4: dw      0
;
; another algorithm for dword multiply
;
DWMul2  equ    $
        push    cx       ; save regs
        push    bx
        xor     ax,ax
        mov     [MULWK3],ax; initialize upper 32bits of 64bit variable
        mov     [MULWK4],ax
;
        mov     bx,di
        call    HexDecml ; convert second string buffer to hex
        mov     [MULWK5],ax; save second value
        mov     [MULWK6],dx
;
        mov     bx,si
        call    HexDecml ; convert first string buffer to hex
        mov     cx,ax
        mov     bx,dx
;
        mul     word ptr[MULWK5]; FirstLo * SecondLo
        mov     [MULWK1],ax; store result(b0-b31)
        mov     [MULWK2],dx
;
        mov     ax,cx
        mul     word ptr[MULWK6]; FirstLo * SecondHi
        add     [MULWK2],ax; add result(b16-b47)
        adc     [MULWK3],dx
        adc     [MULWK4],0
;
        mov     ax,bx
        mul     word ptr[MULWK5]; FirstHi * SecondLo
        add     [MULWK2],ax; add result(b16-b47)
        adc     [MULWK3],dx
        adc     [MULWK4],0
;
        mov     ax,bx
        mul     word ptr[MULWK6]; FirstHi * SecondHi
        add     [MULWK3],ax; add result(b32-b64)
        adc     [MULWK4],dx
;
        mov     ax,[MULWK1]; get result(64bits)
        mov     dx,[MULWK2]
        mov     cx,[MULWK3]
        mov     bx,[MULWK4]
        or      cx,bx
        jz      $+3
        stc              ; carry if overflow
;
        pop     bx       ; restore regs
        pop     cx
        ret
;
MULWK5: dw      0
MULWK6: dw      0
;
DwordDiv equ    $
        push    si       ; save regs
        push    di
        xor     ax,ax
        mov     [DIVWK1],ax; initialize with zero
        mov     [DIVWK2],ax
;
        mov     bx,si
        call    HexDecml ; convert first string buffer to hex
        push    ax       ; save first value
        push    dx
;
        mov     bx,di
        call    HexDecml ; convert second string buffer to hex
        pop     bx       ; restore first value
        pop     cx
;
        mov     si,1     ; bit pointer
        xor     di,di
;
        or      dx,dx    ; 0 div check
        jnz     DWDiv10
        or      ax,ax
        jz      DWDivRet ; 0 Divide error
;
        xchg    dx,ax    ; shift left 16bits
        xchg    di,si
        cmp     bx,dx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
;
        or      dh,dh    ; check b24-b31
        jnz     DWDiv10  ; branch not zero
;
        xchg    dh,dl    ; shift left 24bits
        mov     di,0100h
;
; shift left until divider is greater than divident
;
DWDiv10:
        cmp     bx,dx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
        jnz     DWDiv20
        cmp     cx,ax
        jc      DWDiv70  ; branch if less
;
DWDiv20:
        sal     si,1     ; left shift bit pointer
        rcl     di,1
        sal     ax,1     ; left shift divider
        rcl     dx,1
        jmp     DWDiv10
;
DWDiv30:
        cmp     bx,dx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
        jnz     DWDiv50
        cmp     cx,ax
        jc      DWDiv70  ; branch if less
DWDiv50:
        sub     cx,ax    ; subtract divider
        sbb     bx,dx
        or      [DIVWK1],si; add to result
        or      [DIVWK2],di
DWDiv70:
        shr     dx,1     ; right shift divider
        rcr     ax,1
        shr     di,1     ; right shift bit pointer
        rcr     si,1
        jnc     DWDiv30  ; loop while bit pointer exist
;
DWDivRet:
        mov     ax,[DIVWK1]; get result
        mov     dx,[DIVWK2]
        pop     di       ; restore regs
        pop     si
        ret
;
DIVWK1: dw      0
DIVWK2: dw      0
;
; Subroutine NumInput
; BX = IN:Buffer address
; CX = IN:Max input digits
;
NumInput equ    $
        pushf            ; save regs
        push    ax
        push    dx
        push    di
        push    cx
        mov     al,00h   ; null code
        mov     di,bx
        cld              ; increase direction
        rep              ; repeat
        stosb            ; fill buffer with zero
;
        pop     cx       ; restore counter
        mov     di,bx    ; restore buffer address
InpLoop:
        mov     ah,07h   ; input from stdin(no echo)
        int     21h
        cmp     al,0dh   ; compare with CR
        jz      InpComp
;
        cmp     al,30h   ; compare with '0'
        jc      Beep
        cmp     al,39h   ; compare with '9'
        jle     Echo
;
Beep:
        mov     dl,07h   ; BEL code
        mov     ah,02h   ; output to stdout
        int     21h
        jmp     InpLoop  ; get next key code
Echo:
        jcxz    Beep     ; buffer full, just wait for CR
        stosb            ; store to buffer
        dec     cx       ; decrement counter
;
        mov     dl,al    ; output character
        mov     ah,02h   ; output to stdout
        int     21h
        jmp     InpLoop  ; get next key code
;
InpComp:
        mov     dx,CRLF  ; CR/LF
        mov     ah,09h   ; display string function
        int     21h
;
        pop     di       ; restore regs
        pop     dx
        pop     ax
        popf
        ret
;
CRLF:   db      13,10,'$'
;
;
; Subroutine HexDecml
; BX = IN:Source string address
; CX = IN:Max input digits
; DX:AX = OUT:DWORD value
;
HexDecml equ    $
        pushf            ; save regs
        push    cx
        push    si
        xor     ax,ax    ; clear VALUE
        mov     [HEXWK1],ax
        mov     [HEXWK2],ax
        mov     si,bx
        cld
;
HexLoop:
        test    byte ptr[si],0ffh; terminator?
        jz      HexComp  ; branch if so
;
        mov     ax,[HEXWK1]; multiply VALUE with 10
        mov     dx,[HEXWK2]
        sal     ax,1
        rcl     dx,1
        mov     [HEXWK1],ax
        mov     [HEXWK2],dx
;
        sal     ax,1
        rcl     dx,1
        sal     ax,1
        rcl     dx,1
        add     [HEXWK1],ax
        adc     [HEXWK2],dx
;
        lodsb
        sub     al,30h   ; get hex value
        cbw
        add     [HEXWK1],ax; add as least significant digit
        adc     word ptr[HEXWK2],0
        loop    HexLoop
;
HexComp:
        mov     ax,[HEXWK1]; restore regs
        mov     dx,[HEXWK2]
        pop     si
        pop     cx
        popf
        ret
;
HEXWK1: dw      0
HEXWK2: dw      0
;
; Subroutine NumOutput
; DX:AX = IN:DWORD value
;
NumOutput equ   $
        pushf            ; save regs
        push    ax
        push    dx
        push    cx
        push    bx
        push    di
        mov     bx,10000
        cmp     dx,bx
        jge     PrintOvf
;
        div     bx
        push    ax       ; save upper digits > 10000
        mov     al,20h   ; space code
        mov     cx,10
        mov     di,DECIMAL
        cld              ; increase direction
        rep              ; repeat
        stosb            ; fill buffer with space code
;
        mov     cx,4
        mov     ax,dx    ; dividant
        mov     bx,10    ; divider
        dec     di       ; decrement store pointer
LowDiv:
        xor     dx,dx    ; clear DX register
        div     bx       ; divide
        add     dl,30h   ; conver to character
        mov     [di],dl  ; store buffer
        dec     di       ; decrement store pointer
        or      ax,ax    ; check dividant
        loopnz  LowDiv   ; loop until zero
;
        pop     dx
        or      dx,dx
        jz      OutComp
;
        jcxz    SkipFill
        std
        mov     al,30h   ; fill '0' if > 10000
        rep              ; repeat
        stosb            ; fill buffer with code
SkipFill:
        mov     ax,dx
;
HiDiv:
        xor     dx,dx    ; clear DX register
        div     bx       ; divide
        add     dl,30h   ; conver to character
        mov     [di],dl  ; store buffer
        dec     di       ; decrement store pointer
        or      ax,ax    ; check dividant
        jnz     HiDiv    ; loop until zero
;
OutComp:
        mov     dx,DECIMAL
OutRet:
        mov     ah,09h   ; display string function
        int     21h
;
        pop     di       ; restore regs
        pop     bx
        pop     cx
        pop     dx
        pop     ax
        popf
        ret
;
PrintOvf:
        mov     dx,OverFlow
        jmp     OutRet
OverFlow:db     "-Overflow-$"
;
DECIMAL:ds      10
        db      '$'
        end
