;*****************************************************
; Sample source program 'Calendar.asm'               *
; Copyright (C) 2014. COHT Inc. All Rights Reserved. *
;*****************************************************
;
; predefined handle value
;
STD_IN  equ     0        ; std_in handle
STD_OUT equ     1        ; std_out handle
STD_ERR equ     2        ; std_err handle
;
; Program Segment Prefix
;
ARG_LEN equ     80h      ; command parameter length
ARG_BUF equ     81h      ; command parameters
;
        ORG     0100H
Entry:
        call    ArgSplit ; split to argument
        mov     al,[ARGC]; get argument count
        cmp     al,2
        jge     $+5
        jmp     BadArg   ; argument error
;
        mov     bx,ARGV
        mov     si,[bx]  ; first argument
        add     bx,2
        call    StrToInt ; get value
        mov     [YEAR],ax
;
        mov     si,[bx]  ; second argument
        call    StrToInt ; get value
        mov     [MONTH],ax
;
        cmp     ax,2     ; Feburary?
        jnz     NoLeapY
;
        mov     ax,[YEAR]; leap year check
        cwd
        mov     cx,4
        xor     bx,bx
        call    DWordDiv ; YEAR / 4
        or      cx,cx
        jnz     NoLeapY  ; bra if rest <> 0
;
        mov     byte ptr LEAP,1; leap year, Feb 29th day exist
        mov     cx,25
        call    DWordDiv ; (YEAR / 4) / 25 = YEAR / 100
        or      cx,cx
        jnz     NoLeapY  ; bra if rest <> 0
;
        mov     byte ptr LEAP,0; none leap year.
        mov     cx,4
        call    DWordDiv ; (YEAR / 100) / 4 = YEAR / 400
        or      cx,cx
        jnz     NoLeapY  ; bra if rest <> 0
;
        mov     byte ptr LEAP,1; leap year, Feb 29th day exist
;
NoLeapY:mov     ax,1     ; any month's 1st day
        mov     [DAY],ax
;
        call    DayOfWk  ; get Day of The Week in AX
        mov     [DOW],ax ; store the day of the week value
;
        mov     dx,ax
        shl     ax,1
        add     ax,dx    ; multiply 3
        neg     ax
        add     ax,18    ; ax = 18 - (rest * 3)
        mov     [StOffset],ax
;
        mov     dx,DOWTitl; Day Of the Week Names
        mov     cx,22
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h

        mov     bx,WeekTop
        mov     cx,4
;
; 1st~4th week
;
WeekLp: mov     dx,[bx]  ; 1st ~ 4th week loop
        add     bx,2
        add     dx,[StOffset]
        push    cx
        push    bx
        mov     cx,20
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
;
        mov     dx,CRLF  ; CR/LF
        mov     cx,2
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
        pop     bx
        pop     cx
        loop    WeekLp
;
; 5th week
;
        mov     ax,[DOW] ; get Day Of The Week
        mov     dx,3
        mul     dx       ; multiply with 3
        mov     si,Days5thW; 5th week's output length
        add     si,[MONTH]; add with month
        dec     si       ; adjust to 0 ~ 11 month
        add     al,[si]  ; add with base columns
        cbw
;
; check leap day existance
;
        cmp     word ptr MONTH,2; Feb?
        jnz     NoLeapD  ; bra if not need
;
        cmp     byte ptr LEAP,0; leap year?
        jz      NoLeapD  ; bra if not
;
        add     ax,3     ; Feb 29th day's columns exist
;
NoLeapD:cmp     ax,0     ; AX <= 0?
        jle     ProcEnd  ; no need to printout
;
        mov     cx,26    ; 5th week total length
        sub     cx,[StOffset]
        cmp     cx,20
        jle     LT7Days  ; last day limit
;
        mov     cx,20
;
LT7Days:cmp     ax,cx    ; over last day or 7 days columns?
        jle     NoCiel1  ; bra if not
;
        mov     ax,cx    ; ciel is cx columns
;
NoCiel1:mov     cx,ax    ; string length
        mov     dx,[bx]  ; string address
        add     bx,2
        push    bx
        add     dx,[StOffset]
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
;
        mov     dx,CRLF  ; CR/LF
        mov     cx,2
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
        pop     bx
;
; 6th week
;
        cmp     word ptr MONTH,2; Feb?
        jz      ProcEnd  ; bra if so
;
        mov     cx,[DOW] ; get Day Of The Week
        cmp     cx,5     ; less than Friday
        jc      ProcEnd
;
        mov     dx,[bx]  ; string address
        add     dx,[StOffset]
;
        mov     si,Days5thW; 5th week's output length
        add     si,[MONTH]; add with month
        dec     si       ; adjust to 0 ~ 11 month
        mov     al,[si]
        cbw
        sub     ax,3     ; 6th week's output length
;
        cmp     cx,6     ; 1st day is Sat?
        jnc     NoCiel2
;
        sub     ax,3     ; trancate offset length
;
NoCiel2:cmp     ax,0
        jle     ProcEnd
;
        mov     cx,ax
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
;
        mov     dx,CRLF  ; CR/LF
        mov     cx,2
        mov     bx,STD_OUT
        mov     ah,40h   ;  write to file handle function
        int     21h
;
ProcEnd:mov     al,0     ; return code
        mov     ah,4ch   ; end program function
        int     21h
;
YEAR:   dw      0
MONTH:  dw      0
DAY:    dw      0
LEAP:   db      0
DOW:    dw      0
StOffset:dw     0
;
WeekTop:dw      Week1,Week2,Week3,Week4,Week5,Week6
;
DOWTitl:db      "Su Mo Tu We Th Fr Sa",13,10
;
Week1:  db      "                   1  2  3  4  5  6  7"
Week2:  db      " 2  3  4  5  6  7  8  9 10 11 12 13 14"
Week3:  db      " 9 10 11 12 13 14 15 16 17 18 19 20 21"
Week4:  db      "16 17 18 19 20 21 22 23 24 25 26 27 28"
Week5:  db      "23 24 25 26 27 28 29 30 31"
Week6:  db      "30 31"
;
Days5thW:db     8,-1,8,5,8,5,8,8,5,8,5,8
;
BadArg:
        mov     dx,PARAERR;
        mov     cx,19
        mov     bx,STD_ERR
        mov     ah,40h   ;  write to file handle function
        int     21h
;
        mov     al,1     ; return code
        mov     ah,4ch   ; end program function
        int     21h
;
PARAERR:db      "Parameter Error !"
CRLF:   db      13,10
;
; subroutine DayOfWk
; word [YEAR]= IN:year
; word [MONTH]= IN:month
; word [DAY]= IN:day
; AX= OUT:Day of the Week(0:Sun,1:Mon,...7:Sat)
;
DayOfWk equ    $
        mov     ax,[YEAR]
        push    ax       ; save YEAR
        mov     ax,[MONTH]
        push    ax       ; save MONTH
        cmp     ax,3     ; Jan or Feb?
        jnc     DOW00    ; bra if not
;
        dec     word ptr YEAR;previous year
        add     ax,12    ; 13th-14th month
DOW00:
        sub     ax,2
        mov     [MONTH],ax
;
        mov     ax,[YEAR]; 365 * Y
        cwd
        mov     cx,365
        xor     bx,bx
        call    DWordMul
        mov     [JULIUSL],ax
        mov     [JULIUSH],dx
;
        mov     ax,[YEAR]; Y / 4
        cwd
        mov     cx,4
        xor     bx,bx
        call    DWordDiv
        add     [JULIUSL],ax
        adc     [JULIUSH],dx
;
        mov     ax,[YEAR]; Y / 100
        cwd
        mov     cx,100
        xor     bx,bx
        call    DWordDiv
        sub     [JULIUSL],ax
        sbb     [JULIUSH],dx
;
        mov     ax,[YEAR]; Y / 400
        cwd
        mov     cx,400
        xor     bx,bx
        call    DWordDiv
        add     [JULIUSL],ax
        adc     [JULIUSH],dx
;
        mov     ax,[MONTH]; M * 30
        cwd
        mov     cx,30
        xor     bx,bx
        call    DWordMul
        add     [JULIUSL],ax
        adc     [JULIUSH],dx
;
        mov     ax,[MONTH]; M * 59 / 100
        cwd
        mov     cx,59
        xor     bx,bx
        call    DWordMul
        mov     cx,100
        xor     bx,bx
        call    DWordDiv
        add     ax,[JULIUSL]
        adc     dx,[JULIUSH]
;
        add     ax,[DAY] ; + D
        adc     dx,0
        sub     ax,5C00H ; - 678912
        sbb     dx,000AH
        mov     cx,7     ; / 7
        xor     bx,bx
        call    DWordDiv
;
        pop     ax
        mov     [MONTH],ax; restore MONTH
        pop     ax
        mov     [YEAR],ax; restore YEAR
;
        mov     ax,3     ; adjust rest value
        add     ax,cx    ; 0:Wed,...6:Tue --> 3:Wed,...9:Tue
        cmp     ax,7
        jc      DOW99
;
        sub     ax,7     ; 7:Sun,8:Mon,9:Tue --> 0:Sun,1:Mon,2:Tue
DOW99:  ret
;
JULIUSL:dw      0
JULIUSH:dw      0
;
; subroutine ArgSplit
; byte [ARGC]= OUT:argument count
; word [ARGV]= OUT:argument string array
;
ArgSplit equ    $
        xor     ax,ax
        mov     [ARGC],al; clear ARGC
        mov     bx,ARGV  ; top of ARGV array
;
        mov     cl,[ARG_LEN]; get command line string length
        xor     ch,ch    ; clear upper byte
        mov     si,ARG_BUF; get command line pointer
        cld              ; increase direction
;
ArgGet:
        jcxz    SplitRet ; jump if end of command line
        lodsb            ; get next letter
        dec     cx       ; decrement counter
        cmp     al,20h   ; printable letter?
        jle     ArgGet   ; jump if not
;
        mov     al,[ARGC]; increment ARGC
        inc     al
        mov     [ARGC],al
        mov     ax,si    ; get parameter address in AX
        dec     ax
        mov     [bx],ax  ; store to ARGV
        add     bx,2     ; ARGV++
;
ParaLoop:
        jcxz    SplitRet ; jump if end of command line
        lodsb            ; get next letter
        dec     cx       ; decrement counter
        cmp     al,20h   ; printable letter?
        jle     ArgGet   ; jump if not
        jmp     ParaLoop ; stay in parameter loop
;
SplitRet:
        ret
;
ARGC:   db      0        ; argument count
ARGV:   dw      0        ; argument vector array
        ds      124      ; 2 * 62byte
;
; subroutine StrToInt
; si= IN:string address
; ax= OUT:Int value
;
StrToInt equ    $
        push    dx       ; save regs
        push    bx
        mov     bx,10    ; multiplier
        xor     ax,ax    ; clear VALUE
        mov     dx,ax
;
StrInt50:
        mov     dl,[si]
        inc     si
        cmp     dl,20h   ; terminator?
        jle     StrIntRet; branch if so
;
        mul     bl       ; multiply VALUE with 10
        sub     dl,30h   ; get hex value
        add     ax,dx    ; add as least significant digit
        jmp     StrInt50
;
StrIntRet:
        pop     bx
        pop     dx
        ret
;
; Subroutine DwordAdd
; DX:AX = IN:DWORD value 1
; BX:CX = IN:DWORD value 2
; DX:AX = OUT:DWORD result(DX:AX + BX:CX)
;
DwordAdd equ    $
        add     ax,cx    ; add as dword
        adc     dx,bx
        ret
;
; Subroutine DwordSub
; DX:AX = IN:DWORD value 1
; BX:CX = IN:DWORD value 2
; DX:AX = OUT:DWORD result(DX:AX - BX:CX)
;
DwordSub equ    $
        sub     ax,cx    ; subtract as dword
        sbb     dx,bx
        ret
;
;
; Subroutine DwordMul
; DX:AX = IN:DWORD value 1
; BX:CX = IN:DWORD value 2
; DX:AX = OUT:DWORD result(DX:AX * BX:CX)
;
DwordMul equ    $
        push    si       ; save regs
        push    di
        mov     si,ax
        mov     di,dx
        xor     ax,ax    ; initialize with zero
        mov     dx,ax
;
DWMul10:
        or      cx,cx    ; calc end?
        jnz     DWMul20  ; branch if not
        or      bx,bx    ; calc end?
        jz      DWMulRet ; branch if so
;
DWMul20:
        shr     bx,1     ; get least significant bit in carry
        rcr     cx,1
        jnc     DWMul50  ; skip if zero
;
        add     ax,si; add first value to result
        adc     dx,di
DWMul50:
        sal     si,1     ; left shift first value
        rcl     di,1
        jmp     DWMul10
;
DWMulRet:
        pop     di       ; restore regs
        pop     si
        ret
;
; Subroutine DwordDiv
; DX:AX = IN:DWORD value 1
; BX:CX = IN:DWORD value 2
; DX:AX = OUT:DWORD result(DX:AX / BX:CX)
; BX:CX = OUT:DWORD rest
;
DwordDiv equ    $
        push    si       ; save regs
        push    di
        mov     si,1     ; bit pointer
        xor     di,di
        mov     [DIVWK1],di; initialize with zero
        mov     [DIVWK2],di
;
        or      bx,bx    ; 0 div check
        jnz     DWDiv10
        or      cx,cx
        jz      DWDivRet ; 0 Divide error
;
        xchg    bx,cx    ; shift left 16bits
        xchg    di,si
        cmp     dx,bx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
;
        or      bh,bh    ; check b24-b31
        jnz     DWDiv10  ; branch not zero
;
        xchg    bh,bl    ; shift left 24bits
        mov     di,0100h
;
; shift left until divider is greater than divident
;
DWDiv10:
        cmp     dx,bx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
        jnz     DWDiv20
        cmp     ax,cx
        jc      DWDiv70  ; branch if less
;
DWDiv20:
        sal     si,1     ; left shift bit pointer
        rcl     di,1
        sal     cx,1     ; left shift divider
        rcl     bx,1
        jmp     DWDiv10
;
DWDiv30:
        cmp     dx,bx    ; comp divident with divider
        jc      DWDiv70  ; branch if less
        jnz     DWDiv50
        cmp     ax,cx
        jc      DWDiv70  ; branch if less
DWDiv50:
        sub     ax,cx    ; subtract divider
        sbb     dx,bx
        or      [DIVWK1],si; add to result
        or      [DIVWK2],di
DWDiv70:
        shr     bx,1     ; right shift divider
        rcr     cx,1
        shr     di,1     ; right shift bit pointer
        rcr     si,1
        jnc     DWDiv30  ; loop while bit pointer exist
;
DWDivRet:
        mov     cx,ax
        mov     bx,dx
        mov     ax,[DIVWK1]; get result
        mov     dx,[DIVWK2]
        pop     di       ; restore regs
        pop     si
        ret
;
DIVWK1: dw      0
DIVWK2: dw      0
;
; subroutine StrLen
; AX = IN:String pointer
; CX = OUT:String length
;
StrLen  equ     $
        pushf            ; save regs
        push    ax
        push    si
        xor     cx,cx    ; clear counter
        mov     si,ax    ; SI is source string
        cld              ; increase direction
;
PrintChr:
        lodsb            ; get one character
        cmp     al,20h   ; comp with space code(separator)
        jle     SpaceChr ; jump if less or equal
;
        inc     cx       ; increment count
        jmp     PrintChr ; loop
;
SpaceChr:
        pop     si       ; restore regs
        pop     ax
        popf
        ret
;
        end
