;*****************************************************
; Sample source program 'InputDec.asm'               *
; Copyright (C) 2014. COHT Inc. All Rights Reserved. *
;*****************************************************
        ORG     0100H
Entry:
        mov     di,BUFFER
        mov     al,00h   ; null code
        mov     cx,5     ; 5 letters
        cld              ; increase direction
        rep              ; repeat
        stosb            ; fill buffer with zero
;
        mov     di,BUFFER
        mov     cx,5     ; 5 letters
InpLoop:
        mov     ah,07h   ; input from stdin(no echo)
        int     21h
        cmp     al,0dh   ; compare with CR
        jz      HexDecml
;
        cmp     al,30h   ; compare with '0'
        jc      Beep
        cmp     al,39h   ; compare with '9'
        jle     Echo
;
Beep:
        mov     dl,07h   ; BEL code
        mov     ah,02h   ; output to stdout
        int     21h
        jmp     InpLoop  ; get next key code
Echo:
        jcxz    Beep     ; buffer full, just wait for CR
        stosb            ; store to buffer
        dec     cx       ; decrement counter
;
        mov     dl,al    ; output character
        mov     ah,02h   ; output to stdout
        int     21h
        jmp     InpLoop  ; get next key code
;
HexDecml:
        mov     dx,CRLF  ; CR/LF
        mov     ah,09h   ; display string function
        int     21h
;
        mov     si,BUFFER; buffer address
        mov     cx,5     ; 5 letters
        mov     bl,10    ; multiplier
        xor     ax,ax    ; clear VALUE
;
MulLoop:
        mov     dl,[si]
        inc     si
        or      dl,dl    ; terminator?
        jz      ConvStr  ; branch if so
;
        mul     bl       ; multiply VALUE with 10
        sub     dl,30h   ; get hex value
        add     ax,dx    ; add as least significant digit
        loop    MulLoop
;
ConvStr:
        mov     [VALUE],ax; store value
;
        mov     di,DECIMAL
        mov     al,20h   ; space code
        mov     cx,5     ; 5 letters
        rep              ; repeat
        stosb            ; fill buffer with space code
;
        mov     ax,[VALUE]; dividant
        mov     bx,10    ; divider
DivLoop:
        dec     di       ; decrement store pointer
        cwd              ; clear DX register
        div     bx       ; divide
        add     dl,30h   ; conver to character
        mov     [di],dl  ; store buffer
        or      ax,ax    ; check dividant
        jnz     DivLoop  ; loop until zero
;
        mov     dx,DECIMAL
        mov     ah,09h   ; display string function
        int     21h
        mov     al,0     ; return code
        mov     ah,4ch   ; end program function
        int     21h
;
BUFFER: ds      5
VALUE:  dw      0
DECIMAL:ds      5
CRLF:   db      13,10,'$'
        end
